from collections import defaultdict
from pathlib import Path
from claws.aws_utils import AWSConnector

# NB this is a giant hack to work around the fact that the billing API does not yet exist
# and the data is not yet available in the API response- and yet- the product team
# will not allow us to retire labs reports without this functionality being in place.
# The data to populate this comes from the quarterly registration summaries that are
# generated by the "billybob" project, which, in turn, **scrapes* the needed data
# from the admin console. The resulting files must be manually generated and copied into
# path defined below.
# I know, head-desk.
QUARTERLY_DEPOSIT_DIR = "/home/martin/Documents/Programming/crossref/billing-reports-data-center/quarterlies"


def get_quarterlies_from_s3(member_id):
    """gets list of prefixes for given bucket and prefix"""
    bucket = "outputs.research.crossref.org"
    connector = AWSConnector(bucket=bucket)
    s3_resource = connector.s3_resource
    prefix = f"quarterlies/{member_id}/"

    list_of_prefixes = []
    paginator = s3_resource.meta.client.get_paginator("list_objects")
    for result in paginator.paginate(
        Bucket=bucket, Prefix=prefix, Delimiter="/"
    ):
        if "CommonPrefixes" in result:
            prefixes = [
                f["Prefix"].split("/")[-2] for f in result["CommonPrefixes"]
            ]
            list_of_prefixes.extend(prefixes)
    return list_of_prefixes


def load_quarterlies_from_s3():
    quarterly_data_available = defaultdict(lambda: defaultdict(list))

    bucket = "outputs.research.crossref.org"
    connector = AWSConnector(bucket=bucket)
    prefix = f"quarterlies"

    bucket_obj = connector.bucket

    for object_summary in bucket_obj.objects.filter(Prefix=prefix):
        split_object = object_summary.key.split("/")
        member_id = split_object[-3]
        period = split_object[-2]

        quarterly_data_available[member_id][period] = object_summary.key

    return quarterly_data_available


def get_all_quarterly_summaries(dir):
    return list(Path(dir).rglob("all.parquet"))


def load_quarterly_data():
    quarterly_data_available = defaultdict(lambda: defaultdict(list))
    for path in get_all_quarterly_summaries(QUARTERLY_DEPOSIT_DIR):
        member_id, period, fn = path.parts[-3:]
        quarterly_data_available[member_id][period] = str(path)
    return quarterly_data_available


if __name__ == "__main__":
    # print(load_quarterly_data())
    print(load_quarterlies_from_s3())
    # print(get_quarterlies_from_s3("7859"))
